#!/bin/sh
#simple script to remaster the puppy2 live-cd.
#(c) Copyright 2006 Barry Kauler, www.puppyos.com
# upgraded by Dougal, Oct. 06 (based on script from 2.10-beta)
## update: Nov 14th 2006 -- fixed problem with using ramdisk
## and add the ZDRV code
## update: Nov 16th -- fixed problem introduced above (mounted partitions were's offered for use) ; changed mounting to /mnt/data to a temp dir, in case /mnt/data used already 
## last update: Nov 17th -- fixed problem with full HD install not having /initrd directory: introduced RO2DIR

#variables created at bootup by /initrd/usr/sbin/init...
#. /etc/rc.d/PUPSTATE #v2.02
#PUPMODE=current operating configuration,
#PDEV1=the partition have booted off, DEV1FS=f.s. of PDEV1,
#PUPSFS=graf_201.sfs versioned name, stored on PDEV1, PUPSAVE=vfat,sda1,/grf_save.3fs

GRAFPUPVERSION="`cat /etc/grafpupversion`"
#if [ $GRAFPUPVERSION -gt 211 ];then
	ZDRV="zdrv_$GRAFPUPVERSION.sfs"
	FRSTMESSAGE="5 main files: vmlinuz, isolinux.cfg, initrd.gz, zdrv.sfs,"
	SCNDMESSAGE=" and $ZDRV"
#else
#	FRSTMESSAGE="4 main files: vmlinuz, isolinux.cfg, initrd.gz,"
#	SCNDMESSAGE=""
#fi
#SAVEPART="$PDEV1"
#CDR="/dev/$SAVEPART"

##### Welcome message...
Xdialog --left --title "Remaster Grafpup2" --msgbox "Welcome!

This little program takes a snapshot of your current system 
and gives you three options:
1) burn new CD/DVD
2) create new iso file
3) only create a new graf_$GRAFPUPVERSION.sfs file (for those with a \"frugal\" install) 

A Grafpup2 live-CD has $FRSTMESSAGE and
graf_$GRAFPUPVERSION.sfs, where $GRAFPUPVERSION is the current version number (without dots).

It is the last file that mainly interests us here: it has the entire Puppy
filesystem, everything from '/' down. 

What this script does is rebuild this file graf_$GRAFPUPVERSION.sfs, with everything
currently under '/' -- that is, all installed packages (DotPups and
PupGets), all mounted .sfs extension files, everything, gets combined
into one file, graf_$GRAFPUPVERSION.sfs, and burnt to CD (or not, if you choose not to).

Note: if you have an 'underdog Linux' mounted, that too will get combined
into the graf_$GRAFPUPVERSION.sfs file, so beware, it could get big!

Click OK button to continue..." 0 0

[ ! $? -eq 0 ] && exit
#####
##### ask for type of remaster - pristine /root or not #####
RMSTRTYPE=`Xdialog --stdout --left --title "Remaster Grafpup2" --no-tags  --menubox "There are two ways of remastering:
1) The simple way: Copy ALL of the filesystem, basically
duplicating your current setup, including any junk you have
in your /root directory.

2) Smarter way: Copy filesystem but use "pristine" copies of
/root and /etc. This should give you your current setup -- and
make a smaller iso -- but could miss some configuration files.

Note that in both cases you have the option of customizing the
iso for your hardware or not.

Please select the one you would like to use,
then press OK:" 0 0 3 "1" "Simple" "2" "Smart"`
[ ! $? -eq 0 ] && exit
[ $RMSTRTYPE -eq 1 ] && ALLROOT="yes" 

########## find a partition to work on ##########
##### calc size needed on partition...
xmessage -center -bg "orange" -buttons "" -title "Remaster Grafpup2" "Calculating needed working space.
Please wait, this may take awhile..." &
XPID=$!
SIZEOPT=0
SIZEBIN=`du -sk /bin | cut -f 1`
SIZESBIN=`du -sk /sbin | cut -f 1`
SIZELIB=`du -sk /lib | cut -f 1`
SIZEUSR=`du -sk /usr | cut -f 1`
SIZEROOT=`du -sk /root | cut -f 1`
[ -d /opt ] && SIZEOPT=`du -sk /opt | cut -f 1`
sync
kill $XPID >/dev/null 2>&1
SIZETOTALK=`expr $SIZEBIN + $SIZESBIN + $SIZELIB + $SIZEUSR + $SIZEROOT + $SIZEOPT`
SIZETOTALM=`expr $SIZETOTALK \/ 1024`
echo "SIZETOTALM=$SIZETOTALM"
#estimate a compressed size...
SIZENEEDEDM=`expr $SIZETOTALM \/ 3`
SIZESLACKM=`expr $SIZENEEDEDM \/ 4` #guess
SIZENEEDEDM=`expr $SIZENEEDEDM + $SIZESLACKM`
SIZENEEDEDM=`expr $SIZENEEDEDM + 5` #space for vmlinuz, initrd.gz, etc
#####
##### create partition list
PARTSLIST="`probepart -m 2> /dev/null | grep -v '/dev/fd0' | grep '^/dev/' | grep --extended-regexp 'ext2|ext3|reiserfs|msdos|vfat' | cut -f 1-3 -d '|'`"
# added so it's used instead of mnt/data, just in case...
mkdir /mnt/remaster-temp 
echo "PARTSLIST is |$PARTSLIST|"	#
echo -n "" > /tmp/schoices.txt
echo "$PARTSLIST" | while read APART
do
	ATAG="`echo -n "$APART" | cut -f1 -d'|' | cut -f3 -d '/'`"
	ASIZE="`echo -n "$APART" | cut -f3 -d'|'`"
	AFS="`echo -n "$APART" | cut -f2 -d'|'`"
	AFREE="`df -m | grep "/dev/$ATAG" | tr -s " " | cut -f 4 -d " "`"
echo "APART is |$APART|, ATAG is |$ATAG|, ASIZE is |$ASIZE|, AFS is |$AFS|, AFREE is |$AFREE|" # 
	if [ "$AFREE" = "" ];then
		mount -t $AFS /dev/$ATAG /mnt/remaster-temp > /dev/null 2>&1
		if [ $? -eq 0 ];then
			AFREE="`df -m | grep "/dev/$ATAG" | tr -s " " | cut -f 4 -d " "`"
			umount /mnt/remaster-temp
			echo -n "${ATAG} \"Filesystem: $AFS  Size: ${ASIZE}M  Free: ${AFREE}M\" \\" >> /tmp/schoices.txt
		else
			echo "couldn't mount /dev/$ATAG"
		fi
	else
		echo -n "${ATAG} \"Filesystem: $AFS  Size: ${ASIZE}M  Free: ${AFREE}M\" \\" >> /tmp/schoices.txt
	fi
done
rmdir /mnt/remaster-temp
#add tmpfs ramdisk choice...
SIZETMPFSM="`df -m | grep '^tmpfs' | grep '/initrd/graf_rw' | tr -s " " | cut -f 4 -d " "`"
if [ ! "$SIZETMPFSM" = "" ];then
	echo "ramdisk \"Filesystem: tmpfs  Size: nnn  Free: ${SIZETMPFSM}M\" \\" >> /tmp/schoices.txt
fi
#####
##### create partition-choice dialog script
 SCHOICES="`cat /tmp/schoices.txt`"

 echo '#!/bin/sh' > /tmp/savedlg
 echo -n "Xdialog --stdout --left --title \"Remaster Grafpup2\" --menubox \"A working area is required in which to create the new ISO file.
Here are the available partitions. You must choose one that has at least
${SIZENEEDEDM}M free space on it (twice as much, if you want to create an iso without burning it).

If the partition that you would like to use has less than ${SIZENEEDEDM}M free space
on it, you will need to quit this script and delete some files.
Note 1: you can use the tmpfs ramdisk, which is in RAM, if it has enough space.
Note 2: you can use a usb drive, but it needs to have been plugged in before
        running this script, so that it will get detected.

Highlight desired choice then click OK button...\" 0 0 5 " >> /tmp/savedlg
 echo "$SCHOICES"  >> /tmp/savedlg
# echo ' > /tmp/tag.txt' >> /tmp/savedlg
 chmod 755 /tmp/savedlg
#####
##### run dialog script-- get the working partition
#/tmp/savedlg
WKGPART="`/tmp/savedlg`"
[ ! $? -eq 0 ] && exit
#WKGPART="`cat /tmp/tag.txt`"
echo "WKGPART=$WKGPART"
[ "$WKGPART" = "" ] && exit
#####
########## end find partition ##########

########## get source of iso files ##########
##### ask
MYSRC=`Xdialog --stdout --left --title "Remaster Grafpup2" --menubox "The following files are required to create the new ISO:
vmlinuz, isolinux.bin, isolinux.cfg, initrd.gz$SCNDMESSAGE.

To get them, you can either insert the original Puppy-$GRAFPUPVERSION cd
into a cd-drive, or select a directory that contains them.

(If all you want is to create a new graf_$GRAFPUPVERSION.sfs file, you 
don't need the above files -- choose the \"no iso\" option)

Make your pick..." 0 0 4 "1" "use cd" "2" "select directory" "3" "no iso" `
[ ! $? -eq 0 ] && exit
#####

if [ $MYSRC -eq 2 ]; then
##### directory option selected
	while true 
	do
		SRCDIR="`Xdialog --stdout --left --title "Select Directory" --dselect "/" 0 0`"
		[ ! $? -eq 0 ] && exit
		if [ -f "$SRCDIR"isolinux.bin ] && [ -f "$SRCDIR"isolinux.cfg ] && [ -f "$SRCDIR"vmlinuz ] && [ -f "$SRCDIR"initrd.gz ] ;then
			if [ ! "$ZDRV" = "" ] && [ ! -f $SRCDIR$ZDRV ]; then
				echo "$ZDRV missing"
			else
				MAKEISO="yes"
				break
			fi
		fi
		Xdialog --title "Remaster Grafpup2" --msgbox "ERROR: not all the required files were found 
		in the directory $SRCDIR
		The required files are:vmlinuz, isolinux.bin, isolinux.cfg, initrd.gz$SCNDMESSAGE.
		Try again." 0 0
		[ ! $? -eq 0 ] && exit
	done
elif [ $MYSRC -eq 1 ]; then
##### cd option selected
## get drive:	
	DRIVESFND="`probedisk 2>&1`"
	IDEDRVSFND="`test-eide 2>&1 | grep "cdrom"`"
	SELECTIONS="`echo "$DRIVESFND" | grep '^/dev/' | grep -i "cd" | grep -i "rom" | cut -f 1,3 -d "|" | tr " " "_" | tr "|" " " | tr '$' "_"`"
	CDDRIVE="`Xdialog --left --title "Remaster Grafpup2" --stdout --menubox "Please select a CD/DVD drive.
	(if the Puppy-$GRAFPUPVERSION cd is not already in it, insert it first)
	
	Choose the CD/DVD drive..." 0 48 4 $SELECTIONS 2> /dev/null `"
	[ ! $? -eq 0 ] && exit
	[ "$CDDRIVE" = "" ] && exit
	CDDRIVE="`echo -n "$CDDRIVE" | cut -f 3 -d '/'`"
##
## check if cd already mounted:
	CDMNTPT="`mount | grep "/dev/$CDDRIVE" | tr -s " " | cut -f 3 -d " "`"
	if [ ! "$CDMNTPT" = "" ];then
		if [ ! -f $CDMNTPT/initrd.gz ];then
			fuser -k -m /dev/$CDDRIVE
			sync
			umount /dev/$CDDRIVE 2> /dev/null
			if [ ! $? -eq 0 ];then
				Xdialog --title "ERROR" --msgbox "Mounted CD, get rid of it before running this program!" 0 0
				exit
			fi
		CDMNTPT=""
		fi
	fi
##
## mount the cd:
	if [ "$CDMNTPT" = "" ];then
		while [ 1 ];do
			Xdialog --title "Remaster Grafpup2" --msgbox "Please insert the current Puppy live-CD into drive $CDDRIVE.
Then click OK..." 0 0
			[ ! $? -eq 0 ] && exit
 #now mount it...
			CDMNTPT="/mnt/$CDDRIVE"
			mkdir /mnt/$CDDRIVE 2> /dev/null
			mount -t iso9660 /dev/$CDDRIVE /mnt/$CDDRIVE
			[ $? -eq 0 ] && break
		done
	fi
##
	MAKEISO="yes"
	USECD="yes"
	SRCDIR="$CDMNTPT/"
fi
########## end source selection ##########

## create working directory...
WKGMNTPT="`mount | grep "/dev/$WKGPART" | tr -s " " | cut -f 3 -d " "`"
[ "$WKGPART" = "ramdisk" ] && WKGMNTPT="/initrd/graf_rw"

if [ "$WKGMNTPT" = "" ];then # if not mounted - mount
		WKGFS="`echo "$SCHOICES" | grep "^$WKGPART" | cut -f 2 -d ':' | cut -f 2 -d " "`"
		[ "$WKGFS" = "msdos" ] && WKGFS="vfat"
		WKGMNTPT="/mnt/$WKGPART"
		[ -d $WKGMNTPT ] || mkdir $WKGMNTPT 2> /dev/null
		mount -t $WKGFS /dev/$WKGPART /mnt/$WKGPART
		MOUNTEDPART="yes"
fi

[ "$WKGMNTPT" = "/" ] && WKGMNTPT=""
[ "$WKGMNTPT" = "/initrd/graf_rw" ] && WKGMNTPT="" #usr / for working
[ "$WKGMNTPT" = "/initrd/mnt/dev_save" ] && WKGMNTPT="/mnt/home"

WKGDIR="$WKGMNTPT/puppylivecdbuild"
rm -rf $WKGDIR #precaution
mkdir $WKGDIR
##
echo "created working directory"
##### get files from source...
if [ "$MAKEISO" = "yes" ]; then
	xmessage -center -bg "orange" -buttons "" -title "Remaster Grafpup2" "Copying files from $SRCDIR 
	to $WKGDIR/, please wait..." &
	XPID=$!

# copy the files...
   sync
   cp -a "$SRCDIR"img $WKGDIR/
   sync
   cp "$SRCDIR"Autorun.inf $WKGDIR/
   sync
   cp "$SRCDIR"boot.cat $WKGDIR/
   sync
   cp "$SRCDIR"boot.msg $WKGDIR/ 2> /dev/null
   sync
   cp "$SRCDIR"initrd.gz $WKGDIR/
   sync
   cp "$SRCDIR"isolinux.bin $WKGDIR/
   sync
   cp "$SRCDIR"isolinux.cfg $WKGDIR/
   sync
   cp "$SRCDIR"README.html $WKGDIR/
   sync
   cp "$SRCDIR"release-notes.htm $WKGDIR/
   sync
   cp "$SRCDIR"vmlinuz $WKGDIR/
   sync
   cp "$SRCDIR""$ZDRV" $WKGDIR/
   sync
#   [ ! "$ZDRV" = "" ] && cp $SRCDIR$ZDRV $WKGDIR/
#   sync
	kill $XPID >/dev/null
fi
#####

##### check if graf_ro2 mounted, if not - ask for graf_xxx.sfs
RO2DIR="/initrd"
## file already mounted on graf_ro2
if [ ! "`mount | grep "$RO2DIR/graf_ro2"`" = "" ];then
	if [ "$USECD" = "yes" ] ; then
		umount "$CDMNTPT" 
		Xdialog --title "Remaster Grafpup2" --msgbox "Finished with the cd,
		you may take it out now." 0 0
		USECD=""
	fi
## if not
else
	# full hd install: doesn't have /initrd
	[ ! -d $RO2DIR ] && RO2DIR="/mnt" && mkdir /mnt/graf_ro2
	## if it's in the source-directory: mount it 
	if [ -f "$SRCDIR"graf_$GRAFPUPVERSION.sfs ]; then
		mount -o loop "$SRCDIR"graf_$GRAFPUPVERSION.sfs $RO2DIR/graf_ro2
		MOUNTEDRO="yes"
	## if not: ask user to find it
	else
		until [ "`basename $PUPRO 2>/dev/null`" = "graf_$GRAFPUPVERSION.sfs" ]; do
			PUPRO="`Xdialog --stdout --left --title "Select graf_$GRAFPUPVERSION.sfs" --fselect "/" 0 0`"
			[ ! $? -eq 0 ] && exit
		done
		mount -o loop "$PUPRO" $RO2DIR/graf_ro2
		MOUNTEDRO="yes"
	fi
fi
#####

########## start making graf_xxx.sfs ##########
xmessage -center -bg "orange" -buttons "" -title "Remaster Grafpup2" "Creating the graf_$GRAFPUPVERSION.sfs file in $WKGDIR/.
This can take quite a long time, so please wait.... and wait...
This window will disappear when graf_$GRAFPUPVERSION.sfs is finally created.
Please wait..." &
XPID=$!

#create new graf_xxx.sfs file...
#problem, as want everything under /, but not /initrd, nor anything mounted in /mnt
mkdir /puppylivecdbuild 2> /dev/null #dummy, only used if wkg partition is the tmpfs.
DIRHOME=""
[ -d /home ] && DIRHOME="/home"
[ -d /sys ] && DIRSYS="/sys"
rm -f $WKGDIR/graf_$GRAFPUPVERSION.sfs 2> /dev/null
sync
#note, /graf_$GRAFPUPVERSION.sfs is not normally there, i relocated it to a separate tmpfs,
#however have not yet done that for multisession-cd/dvd (PUPMODE=77)...
#note, /home could be in underdog linux...
mksquashfs / $WKGDIR/graf_$GRAFPUPVERSION.sfs -e /etc /proc /initrd /var /tmp /archive /mnt /root /puppylivecdbuild $DIRHOME $DIRSYS /graf_$GRAFPUPVERSION.sfs
sync

#add pristine folders (out of current graf_xxx.sfs)...
mksquashfs $RO2DIR/graf_ro2/proc $WKGDIR/graf_$GRAFPUPVERSION.sfs -keep-as-directory
sync
mksquashfs $RO2DIR/graf_ro2/tmp $WKGDIR/graf_$GRAFPUPVERSION.sfs -keep-as-directory
sync
mksquashfs $RO2DIR/graf_ro2/mnt $WKGDIR/graf_$GRAFPUPVERSION.sfs -keep-as-directory
sync

kill $XPID >/dev/null

##### START WORKING ON /root #####
rm -rf /tmp/root 2> /dev/null
## if using the full /root:
if [ "$ALLROOT" = "yes" ] ; then
	cp -a /root /tmp/root
	rm -rf /tmp/root/.thumbnails
	rm -rf /tmp/root/.mozilla/default/Cache
	rm -rf /tmp/root/.mozilla/firefox/*/Cache
	rm -rf /tmp/root/Trash/*
	rm -f /tmp/root/.mozilla/firefox/*/XPC.mfasl
	rm -f /tmp/root/.mozilla/firefox/*/XUL.mfasl
	rm -f /tmp/root/.bash_history
	rm -f /tmp/root/.events.log
	rm -f /tmp/root/.gtk-bookmarks
	rm -f /tmp/root/.ICEauthority	
	rm -f /tmp/root/.config/graveman/graveman.conf
else
## if using a "pristine" /root:
#do some work on /root before add it to the squashfs...
	cp -a $RO2DIR/graf_ro2/root /tmp/root #pristine /root
#copy all of my-applications/
	cp -af /root/my-applications/* /tmp/root/my-applications/
#some dotpups get installed here...
	cp -af /root/my-roxapps/* /tmp/root/my-roxapps/
##window manager config files...
	cp -af /root/.jwmrc /tmp/root/
	cp -af /root/.jwmrc-tray /tmp/root/
	cp -af /root/.fvwm95rc /tmp/root/
	cp -af /root/.icewm/menu /tmp/root/.icewm/
# add config for xfce and enlightenment:
	[ -d /root/.config/xfce4 ] && cp -af /root/.config/xfce4 /tmp/root/.config/
	[ -d /root/.config/xfce4-session ] && cp -af /root/.config/xfce4-session /tmp/root/.config/
	[ -d /root/.enlightenment ] && cp -af /root/.enlightenment /tmp/root/
	[ -d /root/.e16 ] && cp -af /root/.e16 /tmp/root/
	[ -L /root/.enlightenment ] && cp -af /root/.enlightenment /tmp/root/

##rox desktop settings...
# new rox
	[ -d /root/.config/rox.sourceforge.net ] && cp -af /root/.config/rox.sourceforge.net /tmp/root/.config/
#this may have been modified for a different w.m...
	cp -af /root/.xinitrc /tmp/root/
#also this...
	[ -f /root/.xset.sh ] && cp -af /root/.xset.sh /tmp/root/

#TODO think need to do this for /var also...

#.packages/ .files, copy any files installed to /root...
	echo -n "" > /tmp/allpkgs.files
	for ONEPKG in `ls -1 /root/.packages/*.files 2>/dev/null | tr "\n" " "`
	do
		for ONEFILE in `cat $ONEPKG | grep '^/root/' | tr "\n" " "`
		do
			DIRNAME="`dirname $ONEFILE`"
			mkdir -p /tmp$DIRNAME
			cp -f $ONEFILE /tmp$DIRNAME/
		done
	done
fi ## if [ "$ALLROOT" = "yes" ]
### the following doesn't work properly: some packages properly registered and recognised by PupGet don't get recognised by the "grep" line... (Dougal)
#### Barry fixed this in 2.11, so I fixed it...

##### modify /root/.packages/ files, as all installed packages are now part of the new cd...
 #integrity check of /root/.packages/alienpackages.txt...
if [ -s /root/.packages/alienpackages.txt ];then
	ZZPATTERN='^".\+" ".\+" .\+ ".*" \\$' #v2.11
	ERRLINE="`cat /root/.packages/alienpackages.txt | grep -v "$ZZPATTERN"`"
	if [ ! "$ERRLINE" = "" ];then
		xmessage -bg '#ff8080' -center -title "ERROR ERROR" "The following line(s) in /root/.packages/alienpackages.txt
has incorrect syntax and has been removed:
$ERRLINE

Please advise the package author that he\/she has stuffed up!
Note, this remaster-CD program can still continue, click button..."
	fi
#  cat /root/.packages/alienpackages.txt | grep '^".\+" ".\+" .\+ ".\+" \\' > /root/.packages/alienpackages.txt
	cat /root/.packages/alienpackages.txt | grep "$ZZPATTERN" > /root/.packages/alienpackages.txt
fi

#any entries in livepackages.txt now "on", transferred to packages.txt...
rm -rf /tmp/root/.packages/*
echo -n "" > /tmp/root/.packages/packages.txt
cp /root/.packages/buildvariables /tmp/root/.packages/
#tricky, packages.txt lines have "\" on ends, which stuffs up the read...
cat /root/.packages/packages.txt | tr "\\" "|" |
while read ONELINE
do
 [ "$ONELINE" = "" ] && continue #precaution, blank line.
 ONEPKG="^\"`echo -n "$ONELINE" | cut -f 2 -d '"'`\"" #'
  #if alien package with same name, let it override...
  if [ -s /root/.packages/alienpackages.txt ];then
   [ ! "`cat /root/.packages/alienpackages.txt | grep "$ONEPKG"`" = "" ] && continue
  fi
 NEWLINE="`cat /root/.packages/livepackages.txt 2> /dev/null | grep "$ONEPKG" | grep '" on "'`"
 if [ "$NEWLINE" = "" ];then
  echo "$ONELINE" | tr "|" "\\" >> /tmp/root/.packages/packages.txt
 else
  echo "$NEWLINE" >> /tmp/root/.packages/packages.txt
 fi
done
#also handle any alien packages (dotpups will be)...
if [ -s /root/.packages/alienpackages.txt ];then
 cat /root/.packages/alienpackages.txt /tmp/root/.packages/packages.txt |
 sort > /tmp/root/.packages/packages.txt
fi
#####
##### option to modify  the new /root
if [ ! "$ALLROOT" = "yes" ] ; then
ROOTMESSAGE='This is mostly 'pristine', as obviously you do not want all your cache files,
temp files, email files, and other working/temporary files to be burnt onto
the CD.'
fi

Xdialog --left --title "Remaster Grafpup2" --msgbox "This program has created folder /tmp/root, which has everything that is
now going to be added as /root in the graf_$GRAFPUPVERSION.sfs file.
$ROOTMESSAGE
If you are familiar with the workings of Puppy, you might like to take a
look at /tmp/root right now, and possibly change anything that you want.

Please note: although the dotpups installed to your system will become an
integral part of the new cd (not listed as dotpups), they will still appear
in the \"Dotpups\" section of your windowmanager menu! To change that, edit
your current menu file as you desire, then copy it into /tmp/root.
  
(if you think that this program has missed out something important that
 should be burnt into /root on the CD, please report it on the forum)

After examining /tmp/root,
click 'Ok' to add /root in graf_$GRAFPUPVERSION.sfs file..." 0 0
sync
mksquashfs /tmp/root $WKGDIR/graf_$GRAFPUPVERSION.sfs -keep-as-directory
sync
rm -rf /tmp/root
##### END WORKING ON /root #####

##### START WORKING ON /etc #####
rm -rf /tmp/etc 2> /dev/null
#do some work on /etc before add it to the .sfs...
if [ "$ALLROOT" = "yes" ] ; then
	cp -a /etc /tmp/etc
	rm -rf /tmp/etc/dotpup
	rm -f /tmp/etc/.mixervolume
	rm -f /tmp/etc/man.conf
	rm -f /tmp/etc/.XLOADED
	rm -f /tmp/etc/mtab
else 	## if using a "pristine" /etc:
	cp -a $RO2DIR/graf_ro2/etc /tmp/etc #pristine /etc.
#maybe this has been modified...
	cp -af /etc/ld.so.conf /tmp/etc/
	cp -af /etc/windowmanager /tmp/etc/
 
#.packages/ .files, copy any files installed to /etc...
	echo -n "" > /tmp/allpkgs.files
	for ONEPKG in `ls -1 /root/.packages/*.files 2>/dev/null | tr "\n" " "`
	do
		for ONEFILE in `cat $ONEPKG | grep '^/etc/' | tr "\n" " "`
		do
			DIRNAME="`dirname $ONEFILE`"
			mkdir -p /tmp$DIRNAME
			cp -f $ONEFILE /tmp$DIRNAME/
		done
	done
	sync
fi # if [ "$ALLROOT" = "yes" ]

#what about settings for a particular pc?...
MSG1="Hardware customisation was not chosen."
Xdialog --left --title "Remaster Grafpup2" --default-no --yesno "Creating  /etc directory for the new graf_$GRAFPUPVERSION.sfs file.

Do you want it to contain customisations for your hardware?
(Examples are mouse, keyboard, video.)

If you answer 'Yes' here, the live-CD will be preconfigured for your
PC only. Therefore, it is best to answer 'No' if you want to boot
the new live-CD on different PCs.

Click 'Yes' to customise /etc...
Click 'No' button not to customise (recommended)..." 0 0
if [ $? -eq 0 ];then	# if we want to customize...
	MSG1="These files are customised in /etc:
codepage fontmap keyboardtype keymap mousebuttons mousedevice
videomode eth0mode eth1mode resolv.conf localtime TZ cdburnerdevice
dvddevice modemdevice securetelnetrc modprobe.conf rdesktoprc
xextraoptions X11/xorg.conf rc.d/rc.local"
	if [ ! "$ALLROOT" = "yes" ];then	# ...add required files
		cp -af /etc/codepage /tmp/etc/
		cp -af /etc/fontmap /tmp/etc/
		cp -af /etc/keyboardtype /tmp/etc/
		cp -af /etc/keymap /tmp/etc/
		cp -af /etc/mousebuttons /tmp/etc/
		cp -af /etc/mousedevice /tmp/etc/
		cp -af /etc/videomode /tmp/etc/
		cp -af /etc/eth0mode /tmp/etc/
		cp -af /etc/eth1mode /tmp/etc/
		cp -af /etc/resolv.conf /tmp/etc/
		rm -f /tmp/etc/localtime #a symlink
		cp -af /etc/localtime /tmp/etc/
		cp -af /etc/TZ /tmp/etc/
		cp -af /etc/cdburnerdevice /tmp/etc/
		cp -af /etc/dvddevice /tmp/etc/
		cp -af /etc/modemdevice /tmp/etc/
		cp -af /etc/securetelnetrc /tmp/etc/
		cp -af /etc/modules.conf /tmp/etc/
		cp -af /etc/modprobe.conf /tmp/etc/
		cp -af /etc/rdesktoprc /tmp/etc/
		cp -af /etc/xextraoptions /tmp/etc/
		cp -af /etc/X11/xorg.conf /tmp/etc/X11
		cp -af /etc/rc.d/rc.local /tmp/etc/rc.d
	fi
else							# if we don't want to customize...
	if [ "$ALLROOT" = "yes" ];then # files already there... remove
		rm -f /tmp/etc/codepage
		rm -f /tmp/etc/fontmap
		rm -f /tmp/etc/keyboardtype
		rm -f /tmp/etc/keymap
		rm -f /tmp/etc/mousebuttons
		rm -f /tmp/etc/mousedevice
		rm -f /tmp/etc/rc.d/rc.local
		rm -f /tmp/etc/rc.d/MORESFS 2>/dev/null
		rm -f /tmp/etc/X11/xorg.conf
		rm -f /tmp/etc/videomode
		rm -f /tmp/etc/eth0mode
		rm -f /tmp/etc/eth1mode
		rm -f /tmp/etc/resolv.conf
		rm -f /tmp/etc/TZ
		rm -f /tmp/etc/cdburnerdevice
		rm -f /tmp/etc/dvddevice
		rm -f /tmp/etc/modemdevice
		rm -f /tmp/etc/securetelnetrc
		rm -f /tmp/etc/modules.conf
		rm -f /tmp/etc/rdesktoprc
		rm -f /tmp/etc/xextraoptions
		cp -a $RO2DIR/graf_ro2/etc/modprobe.conf /tmp/etc/
		cp -a $RO2DIR/graf_ro2/etc/asound.state /tmp/etc/
		echo 'PUPMODE=2' > /tmp/etc/rc.d/PUPSTATE
	fi
fi #if [ $? -eq 0 ]

#some files to always copy...
cp -af /etc/Puppybackgroundcolor /tmp/etc/
cp -af /etc/Puppybackgroundpicture /tmp/etc/
#TODO: other gtk and jwm customisations.

## give option to change /etc manually:
Xdialog --left --title "Remaster Grafpup2" --msgbox "$MSG1

If you know what you are doing, you can now modify any files in the 
/tmp/etc folder. This is just about to be added to /etc in the .sfs file.

Do anything you want before clicking 'Ok'.

(If this program has missed something important, please report it
on the forum)

Click 'Ok' to add /etc in graf_$GRAFPUPVERSION.sfs file..." 0 0

sync
mksquashfs /tmp/etc $WKGDIR/graf_$GRAFPUPVERSION.sfs -keep-as-directory
sync
rm -rf /tmp/etc
##### END WORKING ON /etc #####

##### START WORKING ON /var #####
rm -rf /tmp/var 2> /dev/null
if [ "$ALLROOT" = "yes" ] ; then
	cp -a /var /tmp/var
	echo -n "" > /tmp/var/log/messages
	rm -f /tmp/var/log/X*
	rm -f /tmp/var/lock/LCK*
	rm -f /tmp/var/run/*.pid
else 
	cp -a $RO2DIR/graf_ro2/var /tmp/var #pristine var

#.packages/ .files, copy any files installed to /var...
	echo -n "" > /tmp/allpkgs.files
	for ONEPKG in `ls -1 /root/.packages/*.files 2>/dev/null | tr "\n" " "`
	do
		for ONEFILE in `cat $ONEPKG | grep '^/var/' | tr "\n" " "`
		do
			DIRNAME="`dirname $ONEFILE`"
			mkdir -p /tmp$DIRNAME
			cp -f $ONEFILE /tmp$DIRNAME/
		done
	done
	sync
fi

sync
mksquashfs /tmp/var $WKGDIR/graf_$GRAFPUPVERSION.sfs -keep-as-directory
sync
rm -rf /tmp/var
##### END WORKING ON /var #####
########## end making graf_xxx.sfs ##########

[ "$MOUNTEDRO" = "yes" ] && umount $RO2DIR/graf_ro2
[ "$RO2DIR" = "/mnt" ] && rmdir /mnt/graf_ro2
if [ "$USECD" = "yes" ] ; then
	umount "$CDMNTPT" 
	Xdialog --title "Remaster Grafpup2" --msgbox "Finished with the cd,
	you may take it out now." 0 0
fi
if [ $MYSRC -eq 3 ]; then
	Xdialog --title "Remaster Grafpup2" --msgbox "Your new graf_$GRAFPUPVERSION.sfs file is ready.
	You will find it in mnt/$WKGPART/puppylivecdbuild/
	Goodbye!" 0 0
	exit
fi

##### edit isolinux.cfg...
ISOLINUXCFG="`cat $WKGDIR/isolinux.cfg`"
#small tweaks, like acpi=on, ide=nodma...
Xdialog --left --title "Remaster Grafpup2" --default-no --yesno "Almost ready to burn the CD!
All the files that will be burnt to CD are in $WKGDIR/.

The final thing that you may want to do is edit isolinux.cfg. It has this:
$ISOLINUXCFG

PMEDIA parameter is a hint to Puppy what media you are booting the live-CD from.
'idecd' is the normal internal CD/DVD drive. Other options are:
 usbflash usbhd usbcd ideflash idehd idecd idezip satahd scsihd scsicd
but, since this program is creating a CD, restrict choices to one of the
'cd' options.

PKEYS is the default keyboard layout. Example: 'PKEYS=us'  Choices are:
 be br cf de dk es fi fr gr hu it jp no pl ru se uk us
If you need more choices, the Keyboard Wizard has more, after bootup.

You may also add any kernel parameters. Some PCs require 'acpi=off' to boot
properly (also gives fan, temperature monitoring).

(If you choose 'Yes', an editor will appear, you must
 exit the editor before the program will continue)
Click 'Yes' button to edit isolinux.cfg..." 0 0
if [ $? -eq 0 ];then
 #leafpad $WKGDIR/isolinux.cfg
 gtk-shell -t "$WKGDIR/isolinux.cfg" -ef "$WKGDIR/isolinux.cfg"
 sync
fi
#####

########## create iso / burn ##########
##### select output media
CDCHOICE=`Xdialog --left --stdout --title "Remaster Grafpup2" --menubox "Please choose the media to burn to.

Note 1: this program does not burn a multisession CD/DVD. To do so, choose
the \"create iso\" option, then use another program to burn the CD/DVD.

Note 2: a shortcoming of current version of this program is may fail to
burn to a real (not emulated) SCSI CD burner drive.

Please select one..." 0 0 4 CD-R "New blank recordable CD" DVD-R "New blank DVD-R (not +R, -RW, +RW)" ISO "create iso"`
[ ! $? -eq 0 ] && exit
#####
##### create a script to do the work
echo '#!/bin/sh' > /tmp/new2cd.sh
if [ "$CDCHOICE" = "ISO" ]; then
	ISONAME="$WKGDIR/puppy-$GRAFPUPVERSION-remaster.iso"
	echo "mkisofs -D -R -o "$ISONAME" -b isolinux.bin -c boot.cat -no-emul-boot -boot-load-size 4 -boot-info-table $WKGDIR/" >> /tmp/new2cd.sh
else
	BURNERDRV="`Xdialog --left --title "Remaster Grafpup2" --stdout --menubox "Please select the "$CDCHOICE" burner-drive to use." 0 48 4 $SELECTIONS 2> /dev/null `"
	[ ! $? -eq 0 ] && exit
	[ "$BURNERDRV" = "" ] && exit
	BURNERDRV="`echo -n "$BURNERDRV" | cut -f 3 -d '/'`"
	echo "BURNERDRV=$BURNERDRV"
	case "$CDCHOICE" in
		CD-R)
		echo "mkisofs -D -R -quiet -b isolinux.bin -c boot.cat -no-emul-boot -boot-load-size 4 -boot-info-table $WKGDIR/ | cdrecord -multi -tao -pad -data -v speed=4 gracetime=2 dev=ATAPI:/dev/$BURNERDRV  -" >> /tmp/new2cd.sh
		;;
		DVD-R)
		echo "growisofs -speed=4 -Z /dev/$BURNERDRV -R -D -quiet -b isolinux.bin -c boot.cat -no-emul-boot -boot-load-size 4 -boot-info-table $WKGDIR/" >> /tmp/new2cd.sh
	esac
fi

echo 'echo -n "Finished. Press ENTER key to continue: "' >> /tmp/new2cd.sh
echo 'read nippi'  >> /tmp/new2cd.sh
chmod 755 /tmp/new2cd.sh
##### run the script in terminal
rxvt -bg orange -title "Remaster Grafpup2" -e /tmp/new2cd.sh
sync
############# end making iso/cd ##########


if [ "$CDCHOICE" = "ISO" ]; then
	Xdialog --title "Remaster Grafpup2" --msgbox "Your new iso file is ready:
	$ISONAME
	Goodbye!" 0 0
else
	rm -rf /puppylivecdbuild
	rm -rf $WKGDIR
	sync
	[ "$MOUNTEDPART"= "yes" ] && umount $WKGMNTPT
	eject /dev/$CDDRIVE
fi

Xdialog --left --title "Remaster Grafpup2" --msgbox "The remaster is finished.
Just a few last words about it.

(If you run this program from a (i) multi-session CD/DVD ; (ii) full
hard-drive install or (iii) Puppy running totally in RAM, then a
grf_save.3fs file was not used and the text below is irrelevant.)

Please take note:

If you run this program while using a grf_save.3fs file (the Puppy persistent
storage file), then all the additional packages installed to it (and any .sfs
extension files used) have gone into the remaster.

What that means is that you don't need them in the grf_save file anymore.

There shouldn't be any problems if they're still there, but if you want to be on
the safe side, you might want to either
1) uninstall them now.
2) use a new grf_save file (you can boot Puppy into RAM or boot another os,
then delete [or rename] the grf_save file).

Note: do not uninstall packages while running the remaster, as that will also 
\"delete\" the packages from the remaster.

However, you do not even know if your new remaster works!

Perhaps it is best if you boot it to confirm it works alright. Then, if you want,
boot the original Pup again, and delete all the packages.
" 0 0


####THE END######
